#include "testlib.h"
#include <iostream>

using namespace std;

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);
    int n = opt<int>(1);

    int t = rnd.next(1e8, 1e9 - n);
    int s = 1'000'000'000;
    println(n, t, s);
    vector<int> x = rnd.partition(2, n, 0);

    vector<int> num;
    {  // 0-th block
        vector<int> deltas = rnd.partition(x[0] + 1, (int) 1e9 - t - 1, 1);
        int now = t - 1;
        for (int i = 0; i < x[0]; i++) {
            now += deltas[i];
            num.push_back(now);
        }
    }
    vector<int> deltas = rnd.partition(x[1] + 1, t, 1);
    int now = 0;
    for (int i = 0; i < x[1]; i++) {
        now += deltas[i];
        num.push_back(now);
    }
    sort(num.begin(), num.end());
    println(num);

    vector<int> min_pos(n), max_pos(n);
    {
        map<int, vector<int>> items_iter;
        for (int i = 0; i < n; i++) {
            items_iter[max(0, (t - num[i] + s - 1) / s)].push_back(i);
        }
        map<int, int> pref_sum;
        pref_sum[-1] = 0;
        for (auto [a, b]: items_iter) {
            pref_sum[a] = pref_sum.rbegin()->second + b.size();
        }

        int last_iter = -1, printed = 0, buff = 0;
        for (auto [iter_num, items]: items_iter) {
            printed += min(buff, iter_num - last_iter - 1);
            buff = max(0, buff - (iter_num - last_iter - 1));
            for (int i: items) {
                min_pos[i] = printed + 1;
            }
            buff += items.size() - 1;
            printed++;
            last_iter = iter_num;
        }

        buff = 0, last_iter = -1;
        for (int i = n - 1; i > -1; i--) {
            int iter_num = max(0, (t - num[i] + s - 1) / s);
            buff -= min(buff, iter_num - last_iter);
            if (last_iter == iter_num) {
                buff++;
            }
            int print_iter = iter_num + buff;
            auto it = prev(pref_sum.upper_bound(print_iter))->second;
            max_pos[i] = it;
            last_iter = iter_num;
        }
    }

    int q = 200'000;
    println(q);
    while (q--) {
        int ind = rnd.next(0, n - 1);
        int type = rnd.next(0, 5);
        if (type == 0) {
            println(num[ind], max(1, min_pos[ind] - 1));
        } else if (type == 1) {
            println(num[ind], min_pos[ind]);
        } else if (type == 2) {
            println(num[ind], rnd.next(min_pos[ind], max_pos[ind]));
        } else if (type == 3) {
            println(num[ind], max_pos[ind]);
        } else if (type == 4) {
            println(num[ind], min(n, max_pos[ind] + 1));
        } else if (type == 5) {
            println(num[ind], rnd.next(1, n));
        }
    }
}
