#include "testlib.h"

using namespace std;

const int INF = 1'000'000'000;
const int N = 200'000;
int MAX_N[] = {12, 8, 8, 500, 500, N, N, N, N};
int MAX_T[] = {INF, 10, INF, 10, INF, INF, 1, INF, INF};
int MAX_A[] = {INF, 10, INF, INF, INF, INF, INF, INF, INF};
int MAX_Q[] = {INF, INF, INF, INF, INF, 1, INF, INF, INF};


int main(int argc, char *argv[]) {
    registerValidation(argc, argv);

    int group = stoi(validator.group());
    int n = inf.readInt(1, MAX_N[group], "n");
    inf.readSpace();
    int t = inf.readInt(1, MAX_T[group], "t");
    inf.readSpace();
    int s = inf.readInt(1, INF, "s");
    if (group == 7) {
        ensuref(s == INF, "In group 7 s must be 1e9");
    }
    inf.readEoln();

    vector <int> a = inf.readInts(n, 1, MAX_A[group], "a");
    inf.readEoln();
    for (int i = 0; i < n - 1; i++) {
        ensuref(a[i] < a[i + 1], "A is not increasing: a[%d]=%d >= a[%d]=%d]", i + 1, a[i], i + 2, a[i + 1]);
    }
    set <int> st(a.begin(), a.end());

    int q = inf.readInt(1, MAX_Q[group], "q");
    inf.readEoln();
    for (int i = 1; i <= q; i++) {
        int di = inf.readInt(1, INF, format("d_%d", i));
        inf.readSpace();
        int pi = inf.readInt(1, n, format("p_%d", i));
        inf.readEoln();
        ensuref(st.count(di), "d_%d=%d is not in array a", i, di);
    }
    inf.readEof();
    return 0;
}
